
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openeffectslib/fx/connect.hpp>

namespace opl = olib::openpluginlib;

namespace olib { namespace openeffectslib { namespace fx {

bool connect( n_operator_ptr op1, const opl::wstring& f1_name, n_operator_ptr op2, const opl::wstring& f2_name )
{
	if( f1_name.empty( ) || f2_name.empty( ) ) return false;

	opl::wstring f1_type = op1->type_name( f1_name );
	opl::wstring f2_type = op2->type_name( f2_name );

	if( f1_type.empty( ) || f2_type.empty( ) ) return false;

	if( f1_type == v_out_color_typename && f2_type == v_in_color_typename )
	{
		v_node_ptr* out = op2->pointer<v_node_ptr>( f2_name );
		
		out->get( ) = op1;
	}
	else if( f1_type == v_out_audio_typename && f2_type == v_in_audio_typename )
	{
		v_node_ptr* out = op2->pointer<v_node_ptr>( f2_name );
		
		out->get( ) = op1;
	}
	
	return true;
}

bool disconnect( n_operator_ptr op, const opl::wstring& f_name )
{
	if( f_name.empty( ) ) return false;

	opl::wstring f_type = op->type_name( f_name );

	if( f_type.empty( ) ) return false;

	if( f_type == v_in_color_typename )
	{
		v_node_ptr* out = op->pointer<v_node_ptr>( f_name );
		
		out->get( ) = n_operator_ptr( );
	}
	else if( f_type == v_in_audio_typename )
	{
		v_node_ptr* out = op->pointer<v_node_ptr>( f_name );
		
		out->get( ) = n_operator_ptr( );
	}
	
	return true;
}

} } }
