
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openpluginlib/pl/utf8_utils.hpp>
#include <openeffectslib/fx/content_handler_libxml.hpp>

namespace olib { namespace openeffectslib { namespace fx {

namespace
{
#ifdef __cplusplus
extern "C" {
#endif

	// callbacks to interface with libxml2 sax interface.
	void gpu_kernel_startDocument( void* user_data )
	{ }

	void gpu_kernel_endDocument( void* user_data )
	{ }

	void gpu_kernel_startElement( void* user_data, const xmlChar* name, const xmlChar** attrs )
	{
		namespace opl = olib::openpluginlib;
		
		n_operator_gpu_kernel_parser_action* action = static_cast<n_operator_gpu_kernel_parser_action*>( user_data );

		action->set_attrs( const_cast<xmlChar**>( attrs ) );
		action->dispatch( opl::to_wstring( ( const char* ) BAD_CAST name ) );
	}

	void gpu_kernel_endElement( void* user_data, const xmlChar* name )
	{
	}

#ifdef __cplusplus
}
#endif
}

//
content_handler_libxml::content_handler_libxml( )
{
	memset( &handler_, 0, sizeof( xmlSAXHandler ) );

	handler_.startDocument 	= gpu_kernel_startDocument;
	handler_.endDocument 	= gpu_kernel_endDocument;
	handler_.startElement 	= gpu_kernel_startElement;
	handler_.endElement 	= gpu_kernel_endElement;
}

//
n_operator_gpu_kernel_parser_action& content_handler_libxml::get_action( )
{ return action_; }

//
xmlSAXHandler* content_handler_libxml::get_content_handler( )
{ return &handler_; }

//
void content_handler_libxml::set_branch_path( const boost::filesystem::path& branch_path )
{ action_.set_branch_path( branch_path ); }

} } }
