
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openpluginlib/pl/openpluginlib.hpp>
#include <openpluginlib/pl/utf8_utils.hpp>

#include <openeffectslib/fx/n_operator_gpu_kernel.hpp>
#include <openeffectslib/plugins/colour_effect/sepia_tone_plugin.hpp>

namespace fs  = boost::filesystem;
namespace opl = olib::openpluginlib;

namespace olib { namespace openeffectslib { namespace plugins {

fx::n_operator_ptr sepia_tone_plugin::create( const std::wstring& /*options*/ )
{
#ifdef WIN32
	fs::path sepia_k_path( std::string( opl::kernels_path( ).c_str( ) ) + "\\sepia.gpu_kernel", fs::native );
#else
	fs::path sepia_k_path( OPENEFFECTSLIB_KERNELS "/sepia.gpu_kernel", fs::native );
#endif
	
	return fx::n_operator_ptr( new fx::n_operator_gpu_kernel( sepia_k_path ) );
}

} } }
