
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef STILL_IMAGE_SOURCE_OPERATOR_INC_
#define STILL_IMAGE_SOURCE_OPERATOR_INC_

#if _MSC_VER
#pragma warning ( push )
#	pragma warning ( disable:4275 )
#endif

#include <GL/glew.h>

#include <openeffectslib/plugins/openimagelib_source/config.hpp>

#include <openeffectslib/fx/n_operator_gpu.hpp>

namespace olib { namespace openeffectslib { namespace plugins {

//
class OPENIMAGELIB_SOURCE_DECLSPEC still_image_source_operator : public fx::n_operator_gpu
{
public:
	explicit still_image_source_operator( );

	virtual bool update_image( );
	virtual bool dirty( ) const
	{ return true; }

private:
	bool download_image( const boost::filesystem::path& path );

private:
	GLuint id_;
	GLenum target_;
};

} } }

#if _MSC_VER
#	pragma warning ( default:4275 )
#pragma warning ( pop )
#endif

#endif
