
// X3DBZ - An X3D (bzip2 compressed) plugin to sg.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openobjectlib.org.

#ifdef HAVE_CONFIG_H
#include <openlibraries_global_config.hpp>
#endif

#include <fstream>

#if defined ( HAVE_BZIP2 ) && defined ( HAVE_BOOST_IOSTREAMS )
#include <boost/iostreams/filtering_streambuf.hpp>
#include <boost/iostreams/copy.hpp>
#include <boost/iostreams/filter/bzip2.hpp>
#endif

#include <openobjectlib/plugins/x3dbz/x3dbz_plugin.hpp>

namespace fs  = boost::filesystem;
namespace opl = olib::openpluginlib;

namespace olib { namespace openobjectlib { namespace plugins { namespace X3DBZ {

namespace
{
	sg::scene_ptr load_x3dbz( const fs::path& path )
	{
#if defined ( HAVE_BZIP2 ) && defined ( HAVE_BOOST_IOSTREAMS )
		ifstream file( path.native_file_string( ).c_str( ), ios::in | ios::binary );
		iostreams::filtering_streambuf<iostreams::input> in;
		in.push( iostreams::bzip2_decompressor( ) );
		in.push( file );
#endif

		return sg::scene_ptr( );
	}
}

sg::scene_ptr X3DBZ_plugin::load( const fs::path& path, const opl::string& options )
{ return load_x3dbz( path ); }

bool X3DBZ_plugin::store( const fs::path& /*path*/, const sg::scene_ptr& /*root*/ )
{ return false; }

} } } }
