
// X3DZZ - An X3DZ (zlib compressed) plugin to sg.

// Copyright (C) 2005 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <boost/thread/recursive_mutex.hpp>

#include <openobjectlib/plugins/x3dz/x3dz_plugin.hpp>

namespace opl  = olib::openpluginlib;
namespace X3DZ = olib::openobjectlib::plugins::X3DZ;

namespace
{
	void reflib( int init )
	{
		static long refs = 0;
	
		assert( refs >= 0 && L"X3DBZ_plugin::refinit: refs is negative." );
		
		if( init > 0 && ++refs )
		{
		}
		else if( init < 0 && --refs == 0 )
		{
		}
	}
}

extern "C"
{
	X3DZ_DECLSPEC bool openplugin_init( void )
	{
		boost::recursive_mutex mutex;
		
		reflib( 1 );
		
		return true;
	}

	X3DZ_DECLSPEC bool openplugin_uninit( void )
	{
		boost::recursive_mutex mutex;

		reflib( -1 );
		
		return true;
	}

	X3DZ_DECLSPEC bool openplugin_create_plugin( const char*, opl::openplugin** plug )
	{
		*plug = new X3DZ::X3DZ_plugin;
		
		return true;
	}
	
	X3DZ_DECLSPEC void openplugin_destroy_plugin( opl::openplugin* plug )
	{ delete static_cast<X3DZ::X3DZ_plugin*>( plug ); }
}
