
// X3DZ - An X3D (zlib compressed) plugin to sg.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openobjectlib.org.

#ifdef HAVE_CONFIG_H
#include <openlibraries_global_config.hpp>
#endif

#include <fstream>

#if defined ( HAVE_ZLIB ) && defined ( HAVE_BOOST_IOSTREAMS )
#include <boost/iostreams/filtering_streambuf.hpp>
#include <boost/iostreams/copy.hpp>
#include <boost/iostreams/filter/gzip.hpp>
#endif

#include <openobjectlib/plugins/x3dz/x3dz_plugin.hpp>

namespace fs	= boost::filesystem;
namespace opl	= olib::openpluginlib;

namespace olib { namespace openobjectlib { namespace plugins { namespace X3DZ {

namespace
{
	sg::scene_ptr load_x3dz( const fs::path& path )
	{
#if defined ( HAVE_ZLIB ) && defined ( HAVE_BOOST_IOSTREAMS )	
		ifstream file( path.native_file_string( ).c_str( ), ios::in | ios::binary );
		iostreams::filtering_streambuf<iostreams::input> in;
		in.push( iostreams::gzip_decompressor( ) );
		in.push( file );
#endif

		return sg::scene_ptr( );
	}
}

sg::scene_ptr X3DZ_plugin::load( const fs::path& path, const opl::string& options )
{ return sg::scene_ptr( ); }

bool X3DZ_plugin::store( const fs::path& path, const sg::scene_ptr& root )
{ return false; }

} } } }
